"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InternalPackageMetadata = void 0;
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta");
const base_1 = require("@kubernetes-models/base");
const validate_1 = require("@kubernetes-models/validate");
const schemaId = "internal.packaging.carvel.dev.v1alpha1.InternalPackageMetadata";
const schema = {
    "type": "object",
    "properties": {
        "apiVersion": {
            "type": "string",
            "enum": [
                "internal.packaging.carvel.dev/v1alpha1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "InternalPackageMetadata"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        },
        "spec": {
            "properties": {
                "categories": {
                    "items": {
                        "type": "string"
                    },
                    "type": "array",
                    "nullable": true
                },
                "displayName": {
                    "type": "string",
                    "nullable": true
                },
                "iconSVGBase64": {
                    "type": "string",
                    "nullable": true
                },
                "longDescription": {
                    "type": "string",
                    "nullable": true
                },
                "maintainers": {
                    "items": {
                        "properties": {
                            "name": {
                                "type": "string",
                                "nullable": true
                            }
                        },
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "providerName": {
                    "type": "string",
                    "nullable": true
                },
                "shortDescription": {
                    "type": "string",
                    "nullable": true
                },
                "supportDescription": {
                    "type": "string",
                    "nullable": true
                }
            },
            "type": "object"
        }
    },
    "required": [
        "spec",
        "apiVersion",
        "kind"
    ]
};
class InternalPackageMetadata extends base_1.Model {
    constructor(data) {
        super({
            apiVersion: InternalPackageMetadata.apiVersion,
            kind: InternalPackageMetadata.kind,
            ...data
        });
    }
}
exports.InternalPackageMetadata = InternalPackageMetadata;
InternalPackageMetadata.apiVersion = "internal.packaging.carvel.dev/v1alpha1";
InternalPackageMetadata.kind = "InternalPackageMetadata";
InternalPackageMetadata.is = (0, base_1.createTypeMetaGuard)(InternalPackageMetadata);
(0, base_1.setSchema)(InternalPackageMetadata, schemaId, () => {
    (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.addSchema)();
    (0, validate_1.register)(schemaId, schema);
});
