import { addSchema } from "@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta";
import { Model, setSchema, createTypeMetaGuard } from "@kubernetes-models/base";
import { register } from "@kubernetes-models/validate";
const schemaId = "packaging.carvel.dev.v1alpha1.PackageInstall";
const schema = {
    "type": "object",
    "properties": {
        "apiVersion": {
            "type": "string",
            "enum": [
                "packaging.carvel.dev/v1alpha1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "PackageInstall"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        },
        "spec": {
            "properties": {
                "canceled": {
                    "type": "boolean",
                    "nullable": true
                },
                "cluster": {
                    "properties": {
                        "kubeconfigSecretRef": {
                            "properties": {
                                "key": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "name": {
                                    "type": "string",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "namespace": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "noopDelete": {
                    "type": "boolean",
                    "nullable": true
                },
                "packageRef": {
                    "properties": {
                        "refName": {
                            "type": "string",
                            "nullable": true
                        },
                        "versionSelection": {
                            "properties": {
                                "constraints": {
                                    "type": "string",
                                    "nullable": true
                                },
                                "prereleases": {
                                    "properties": {
                                        "identifiers": {
                                            "items": {
                                                "type": "string"
                                            },
                                            "type": "array",
                                            "nullable": true
                                        }
                                    },
                                    "type": "object",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        }
                    },
                    "type": "object",
                    "nullable": true
                },
                "paused": {
                    "type": "boolean",
                    "nullable": true
                },
                "serviceAccountName": {
                    "type": "string",
                    "nullable": true
                },
                "syncPeriod": {
                    "type": "string",
                    "nullable": true
                },
                "values": {
                    "items": {
                        "properties": {
                            "secretRef": {
                                "properties": {
                                    "key": {
                                        "type": "string",
                                        "nullable": true
                                    },
                                    "name": {
                                        "type": "string",
                                        "nullable": true
                                    }
                                },
                                "type": "object",
                                "nullable": true
                            }
                        },
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                }
            },
            "type": "object"
        },
        "status": {
            "properties": {
                "conditions": {
                    "items": {
                        "properties": {
                            "message": {
                                "type": "string",
                                "nullable": true
                            },
                            "reason": {
                                "type": "string",
                                "nullable": true
                            },
                            "status": {
                                "type": "string"
                            },
                            "type": {
                                "type": "string"
                            }
                        },
                        "required": [
                            "status",
                            "type"
                        ],
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "friendlyDescription": {
                    "type": "string",
                    "nullable": true
                },
                "lastAttemptedVersion": {
                    "type": "string",
                    "nullable": true
                },
                "observedGeneration": {
                    "format": "int64",
                    "type": "integer",
                    "nullable": true
                },
                "usefulErrorMessage": {
                    "type": "string",
                    "nullable": true
                },
                "version": {
                    "type": "string",
                    "nullable": true
                }
            },
            "type": "object",
            "nullable": true
        }
    },
    "required": [
        "spec",
        "apiVersion",
        "kind"
    ]
};
export class PackageInstall extends Model {
    constructor(data) {
        super({
            apiVersion: PackageInstall.apiVersion,
            kind: PackageInstall.kind,
            ...data
        });
    }
}
PackageInstall.apiVersion = "packaging.carvel.dev/v1alpha1";
PackageInstall.kind = "PackageInstall";
PackageInstall.is = createTypeMetaGuard(PackageInstall);
setSchema(PackageInstall, schemaId, () => {
    addSchema();
    register(schemaId, schema);
});
